Leetcode House Robber

来源:互联网 发布:中国移动杭州数据 编辑:程序博客网 时间:2024/06/06 16:26

House Robber I题目描述

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

给出一个非负数序列,找到他们不相邻的最大和。这题可以很容易看出,n[k]前的不相邻最大和实际上和n[k - 2]有关,当前状态和前一状态有直接关系时,则为动态规划,因此该题用动态规划是最方便的。

解题思路

确定好DP方向后,sums表示包含第k个元素的1-k的不相邻最大和。可推出式子:

sums[k]=max(sums[0],sums[1],....,sums[k2])+n[k2]

源代码

class Solution {public:    int rob(vector<int>& nums) {        if (nums.empty())   return 0;        if (nums.size() == 1)   return nums[0];        int sums[nums.size()];        for (int i = 0; i < nums.size(); i++) {            int max = 0;            for (int j = 0; j < i - 1; j++) {                if (sums[j] > max)                      max = sums[j];            }            sums[i] = nums[i] + max;            cout << sums[i] << endl;        }        return max(sums[nums.size() - 1], sums[nums.size() - 2]);    }};

House Robber II 题目描述

在题1的基础上,增加了条件:首尾相邻。

解题思路

首尾相邻形成一个圆,那么从哪里开始都是会和前一位相邻。因此,可以将首和尾各自除去后寻找不相邻的最大和。

源代码

class Solution {public:    int rob(vector<int>& nums) {        int n = nums.size();        if (!n) return 0;        if (n == 1) return nums[0];        return max(robber(0, n - 2, nums), robber(1, n - 1, nums));    }    int robber(int s, int e, vector<int>& nums) {        int pre = 0, cur = 0;        for (int i = s; i <= e; i++) {            int temp = max(pre + nums[i], cur);            pre = cur;            cur = temp;        }        return cur;    }};
原创粉丝点击